<html>
<head>
<title>OgreParticleSystemRenderer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreParticleSystemRenderer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreParticleSystemRenderer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __ParticleSystemRenderer_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __ParticleSystemRenderer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringInterface_8h.html">OgreStringInterface.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreFactoryObj_8h.html">OgreFactoryObj.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderQueue_8h.html">OgreRenderQueue.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00049"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html" title="Abstract class defining the interface required to be implemented by classes which provide rendering c...">ParticleSystemRenderer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.">StringInterface</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">FXAlloc</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00053"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a18d83b417a606c9d40f87fffe003ef2a">00053</a>         <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a18d83b417a606c9d40f87fffe003ef2a" title="Constructor.">ParticleSystemRenderer</a>() {}
<a name="l00055"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#acedd9af6338bc40603a571333be5f5f9">00055</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#acedd9af6338bc40603a571333be5f5f9" title="Destructor.">~ParticleSystemRenderer</a>() {}
<a name="l00056"></a>00056 
<a name="l00058"></a>00058         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00059"></a>00059 
<a name="l00065"></a>00065         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue, 
<a name="l00066"></a>00066             <a class="code" href="structOgre_1_1list.html">list&lt;Particle*&gt;::type</a>&amp; currentParticles, <span class="keywordtype">bool</span> cullIndividually) = 0;
<a name="l00067"></a>00067 
<a name="l00069"></a>00069         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setMaterial(<a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat) = 0;
<a name="l00071"></a>00071         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyCurrentCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) = 0;
<a name="l00073"></a>00073         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyAttached(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* parent, <span class="keywordtype">bool</span> isTagPoint = <span class="keyword">false</span>) = 0;
<a name="l00075"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a135d07c57490da7dccb849e0058c2b24">00075</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a135d07c57490da7dccb849e0058c2b24" title="Optional callback notified when particles are rotated.">_notifyParticleRotated</a>(<span class="keywordtype">void</span>) {}
<a name="l00077"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a7d780e51ef230c6e00e53ca6b0f0f3f6">00077</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a7d780e51ef230c6e00e53ca6b0f0f3f6" title="Optional callback notified when particles are resized individually.">_notifyParticleResized</a>(<span class="keywordtype">void</span>) {}
<a name="l00079"></a>00079         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParticleQuota(<span class="keywordtype">size_t</span> quota) = 0;
<a name="l00081"></a>00081         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyDefaultDimensions(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height) = 0;
<a name="l00083"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#aec55835fcde21e77487cfbb20f439944">00083</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#aec55835fcde21e77487cfbb20f439944" title="Optional callback notified when particle emitted.">_notifyParticleEmitted</a>(<a class="code" href="classOgre_1_1Particle.html" title="Class representing a single particle instance.">Particle</a>* particle) {}
<a name="l00085"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a64ca1a8e9f77c857d2ffdab29fbdd598">00085</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a64ca1a8e9f77c857d2ffdab29fbdd598" title="Optional callback notified when particle expired.">_notifyParticleExpired</a>(<a class="code" href="classOgre_1_1Particle.html" title="Class representing a single particle instance.">Particle</a>* particle) {}
<a name="l00087"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a7fd98dec902f124c7c51c1cbe7356364">00087</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a7fd98dec902f124c7c51c1cbe7356364" title="Optional callback notified when particles moved.">_notifyParticleMoved</a>(<a class="code" href="structOgre_1_1list.html">list&lt;Particle*&gt;::type</a>&amp; currentParticles) {}
<a name="l00089"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#aa76e67b53dd09f60313e9ebfb59ed5c0">00089</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#aa76e67b53dd09f60313e9ebfb59ed5c0" title="Optional callback notified when particles cleared.">_notifyParticleCleared</a>(<a class="code" href="structOgre_1_1list.html">list&lt;Particle*&gt;::type</a>&amp; currentParticles) {}
<a name="l00097"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a76d2732e63a02c925cca738e1d55b7e9">00097</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ParticleVisualData.html" title="Abstract class containing any additional data required to be associated with a particle to perform th...">ParticleVisualData</a>* <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#a76d2732e63a02c925cca738e1d55b7e9" title="Create a new ParticleVisualData instance for attachment to a particle.">_createVisualData</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> 0; }
<a name="l00105"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#addc7a41c0c6aba115a7ca23219001690">00105</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html#addc7a41c0c6aba115a7ca23219001690" title="Destroy a ParticleVisualData instance.">_destroyVisualData</a>(<a class="code" href="classOgre_1_1ParticleVisualData.html" title="Abstract class containing any additional data required to be associated with a particle to perform th...">ParticleVisualData</a>* vis) { assert (vis == 0); }
<a name="l00106"></a>00106 
<a name="l00110"></a>00110         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRenderQueueGroup(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> queueID) = 0;
<a name="l00111"></a>00111 
<a name="l00114"></a>00114         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setKeepParticlesInLocalSpace(<span class="keywordtype">bool</span> keepLocal) = 0;
<a name="l00115"></a>00115 
<a name="l00117"></a>00117         <span class="keyword">virtual</span> <a class="code" href="group__General.html#ga73dc0089e326fa37f93a30bf67ba7e3a" title="Sort mode for billboard-set and particle-system.">SortMode</a> _getSortMode(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00118"></a>00118 
<a name="l00123"></a>00123         <span class="keyword">virtual</span> <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00124"></a>00124             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>) = 0;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     };
<a name="l00127"></a>00127 
<a name="l00129"></a><a class="code" href="classOgre_1_1ParticleSystemRendererFactory.html">00129</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParticleSystemRendererFactory.html" title="Abstract class definition of a factory object for ParticleSystemRenderer.">ParticleSystemRendererFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1FactoryObj.html" title="Abstract factory class.">FactoryObj</a>&lt;ParticleSystemRenderer&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">FXAlloc</a>
<a name="l00130"></a>00130     {
<a name="l00131"></a>00131     <span class="keyword">public</span>:
<a name="l00132"></a>00132         <span class="comment">// No methods, must just override all methods inherited from FactoryObj</span>
<a name="l00133"></a>00133     };
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
